/*******************************************************************/
/*                                                                 */
/* Module           : utility.cc                                   */
/* Description      : Implementation file for some useful utility  */
/*                    functions.                                   */
/* Author           : Sebastian Boenisch                           */
/* Email            : Sebastian.Boenisch@iwr.uni-heidelberg.de     */
/* Copyright        : University of Heidelberg                     */
/* Created on       : (see RCS entry below)                        */
/* $Id: utility.cc,v 1.6 2002/03/05 17:45:21 boenisch Exp $        */
/* Last modified by :                                              */
/* Last modified on :                                              */
/* Update count     :                                              */
/*                                                                 */
/*******************************************************************/
/*                                                                 */
/*  Date      Name               Changes/Extensions                */
/*  ====      ====               ==================                */
/*                                                                 */
/*******************************************************************/


#include <iostream>
#include <string>

template <class T> 
T abs(T x) {
  return x>=static_cast<T>(0) ? x : -x;
} // T abs(T x)


template <class T> 
T gcd(T x, T y) {

  while(y > 0) {
    T rem = x % y;
    x = y;
    y = rem;
  }
  return x;
} // T gcd(T x, T y)


template <class T>
T max (T x, T y) {
  if (x >= y)  return x;
  else         return y;
} // T max (T x, T y)


template <class T>
T min (T x, T y) {
  if (x <= y)  return x;
  else         return y;
} // T min (T x, T y)


template <class T>
istream& operator>>(istream& inStream, vector<T>& vector) {
  for (int i=0; i<vector.size(); ++i) 
    inStream >> vector[i];

  return inStream;
} // istream& operator>>(...


template <class T>
ostream& operator<<(ostream& outStream, vector<T>& vector) {
  for (int i=0; i<vector.size(); ++i) { 
    outStream << vector[i];
    outStream << endl     ;
  }

  return outStream;
} // ostream& operator<<(...




