/*******************************************************************/
/*                                                                 */
/* Module           : utility.hh                                   */
/* Description      : Header file for some useful utility          */
/*                    functions.                                   */
/* Author           : Sebastian Boenisch                           */
/* Email            : Sebastian.Boenisch@iwr.uni-heidelberg.de     */
/* Copyright        : University of Heidelberg                     */
/* Created on       : (see RCS entry below)                        */
/* $Id: utility.hh,v 1.8 2002/03/05 17:45:30 boenisch Exp $        */
/* Last modified by :                                              */
/* Last modified on :                                              */
/* Update count     :                                              */
/*                                                                 */
/*******************************************************************/
/*                                                                 */
/*  Date      Name               Changes/Extensions                */
/*  ====      ====               ==================                */
/*                                                                 */
/*******************************************************************/

#ifndef UTILITY_HH
#define UTILITY_HH


#include <iostream>
#include <vector>

/// Returns the absolut value of x.
template <class T> 
T abs(T x);

/// Returns the greatest common divisor of x and y.
template <class T> 
T gcd(T x, T y);

/// Overloads the input operator for vectors.
template <class T>
istream& operator>>(istream& inStream, vector<T>& vector);

/// Generic maximum function.
template <class T>
T max (T, T);

/// Generic minimum function.
template <class T>
T min (T, T);


/* ************************************************** */
/*             Include implementation                 */ 
/* ************************************************** */

#include "utility.cc"



#endif
